local lg = love.graphics

function lg.rectMesh(x, y, w, h, out)
  x = x or 0
  y = y or 0
  out = out or {}
  local n = #out
  out[n + 1] = { x, y }
  out[n + 2] = { x + w, y }
  out[n + 3] = { x + w, y + h }
  out[n + 4] = { x, y }
  out[n + 5] = { x + w, y + h }
  out[n + 6] = { x, y + h }
  return out
end

function lg.drawHole(s1, s2, steps)
  steps = steps or 32
  local x1, y1
  local x2, y2
  for i = 0, steps do
    local r = (i/steps)*(math.pi*2)
    local x3, y3 = math.cos(r)*s1, math.sin(r)*s1
    local x4, y4 = math.cos(r)*s2, math.sin(r)*s2
    if i > 0 then
      lg.polygon("fill", x1, y1, x2, y2, x4, y4, x3, y3)
    end
    x1, y1 = x3, y3
    x2, y2 = x4, y4
  end
end