local lg = love.graphics
--local verts = { {0,0},{600,0},{600,12},{0,12} }
--local mesh = lg.newMesh(verts, "fan", "static")

return function(lvl)
  local view = love.scene.newView()
  view:setBackgroundRGB(0, 0, 0, 0)
  --[[
  local stripe = view:newSprite(0, 0)
  stripe:setGraphic(mesh)
  stripe:setColorRGB(0, 0, 0)
  stripe:setAlpha(0.75)
  ]]

  local fonts = app.fonts
  local text1 = lg.newText(fonts.minib)
  local text2 = lg.newText(fonts.minib)
  local text3 = lg.newText(fonts.minib)
  local text4 = lg.newText(fonts.mini)

  local time = view:newSprite(0, 0)
  local score = view:newSprite(0, 0)
  local lives = view:newSprite(0, 0)
  local status = view:newSprite(0, 0)
  local outline = view:newSprite(0, 0)
  
  function outline:draw()
    local sx, sy = view:getScale()
    local vw, vh = view:getDimensions()
    vw, vh = vw/sx, vh/sy
    lg.setColor(0, 0, 0, 1)
    lg.setLineWidth(1)
    lg.rectangle("line", -vw/2, -vh/2, vw, vh)
  end
  
  time:setGraphic(text1)
  score:setGraphic(text2)
  lives:setGraphic(text3)
  status:setGraphic(text4, -100, -4, 0, 2, 2)
  
  local hud = {}

  function hud.draw(w, h, rw, rh)
    local d = lvl.data
    view:setBackgroundRGB(0, 0, 0, d.message and 198 or 0)
    view:setBounds(0, 0, w, h)
    view:setScale(app.s, app.s)
    view:setShader(app.shaders.default)

    --local leveln = string.format("%s %02d", app.lang.leveln, lvl.title)
    local seconds = app.lang.seconds(lvl.data.elapsed)
    local timen = string.format("🕒%s", seconds)
    local scoren = string.format("💀%05d/%05d", d.score, d.maximum or 0)
    local livesn = string.format("❤%02d", lvl.session.lives)
    text1:setf(timen, rw - 8*2, "left")
    text2:setf(scoren, rw - 8*2, "center")
    text3:setf(livesn, rw - 8*2, "right")
    text4:setf(d.message or "", 100, "center")
    
    time:setPosition(-rw/2 + 8, -rh/2 + 2)
    score:setPosition(-rw/2 + 8, -rh/2 + 2)
    lives:setPosition(-rw/2 + 8, -rh/2 + 2)
    --stripe:setPosition(-rw/2, -rh/2)
    
    view:draw()
    
    -- curtain
    d.curtain = 1 - math.min(d.elapsed/1, 1)
    if d.curtain > 0 and d.curtain <= 1 then
      lg.reset()
      lg.setColor(0, 0, 0, 1)
      lg.translate(w/2, h/2)
      local s1 = math.max(w, h)
      local s2 = s1*(1 - d.curtain)
      lg.drawHole(s1, s2)
    end

    -- letterbox
    lg.reset()
    lg.translate(w/2, h/2)
    lg.setColor(0, 0, 0, 1)
    local lw, lh = rw*app.s, rh*app.s
    local ww, hh = (w - lw)/2, (h - lh)/2
    lg.rectangle("fill", -w/2, -h/2, w, hh)
    lg.rectangle("fill", -w/2, h/2 - hh, w, hh)
    lg.rectangle("fill", -w/2, -h/2, ww, h)
    lg.rectangle("fill", w/2 - ww, -h/2, ww, h)
  end

  return hud
end