local layout = 
{
  { text = app.lang.music, value = 0 },
  { text = app.lang.sfx, value = 0 },
  { text = app.lang.voice, value = 0 },
  { text = app.lang.back },
}

function layout.cancel()
  app.popstate()
  app.callstate("reset")
end

function layout.init()
  layout[1].value = app.ops.mvolume*10
  layout[2].value = app.ops.svolume*10
  layout[3].value = app.ops.vvolume*10
  if app.ops.audio == false or love.audio == nil then
    layout[1].value = 0
    layout[2].value = 0
    layout[3].value = 0
  end
end

function layout.restart(on)
  if on and not app.arg.mobile then
    if not app.ops.audio or not love.audio then
      app.ops.audio = true
      --love.window.minimize()
      local buttons = { "Cancel", "OK", enterbutton = 2, escapebutton = 1 }
      local title = "Restart required"
      local message = "Restart the game for the changes to take effect?"
      local chosen = love.window.showMessageBox(title, message, buttons, "info", false)
      if chosen == 2 then
        love.event.quit("restart")
      end
      love.window.restore()
    end
  end
end

function layout.choose(i, j)
  local q = layout[i]
  if i == 1 and j then
    q.value = j
    app.ops.mvolume = j/10
    app.playMusic(app.track)
    layout.restart(q.value > 0)
    app.callstate("reset")
  elseif i == 2 and j then
    q.value = j
    app.ops.svolume = j/10
    layout.restart(q.value > 0)
    app.callstate("reset")
  elseif i == 3 and j then
    q.value = j
    app.ops.vvolume = j/10
    layout.restart(q.value > 0)
    app.callstate("reset")
  elseif i == #layout then
    layout.cancel()
  end
end

return layout