local layout = 
{
  { text = app.lang.back },
}

local list = {}
for id in pairs(app.attached) do
  table.insert(list, id)
end
table.sort(list)
for _, id in ipairs(list) do
  local name = id
  if name == "Keyboard" then
    name = app.lang["keyboard"]
  end
  local item = { text = name, value = id }
  table.insert(layout, #layout, item)
end

function layout.cancel()
  app.popstate()
  app.callstate("reset")
end

function layout.init()
end

function layout.choose(i)
  local q = layout[i]
  if i < #layout then
    app.pushstate("states.menu", "remap", q.value)
  elseif i == #layout then
    layout.cancel()
  end
end

return layout