local layout = {}

local list = {}
for lc, text in pairs(app.text.locales) do
  table.insert(list, lc)
end
table.sort(list)
table.reverse(list)
for i, lc in ipairs(list) do
  local item = { text = app.text.locales[lc].lang, value = lc }
  table.insert(layout, 1, item)
end

function layout.init()
  local lc = app.ops.language
  if lc == "none" then
    lc = "en"
  end
  for i, v in ipairs(layout) do
    if v.value == lc then
      layout.selected = i
      break
    end
  end
end

function layout.cancel()
  app.popstate()
  app.callstate("reset")
end

function layout.choose(i)
  local q = layout[i]
  app.ops.language = q.value
  app.lang = app.text.locales[q.value]
  app.popstate()
  app.callstate("reset")
end

return layout