local layout = 
{
  position = "bottom",
  { text = app.lang.player1, value = "single" },
  { text = app.lang.player2, value = "coop" },
  { text = app.lang.online, value = "online" },
  { text = app.lang.options, value = "options" },
  { text = app.lang.localize, value = "lang" },
  { text = app.lang.quit, value = "quit" },
}

-- multiplayer options
local n = 0
for id in pairs(app.attached) do
  n = n + 1
end
layout[2].disabled = (n <= 1)
if app.portal and app.exists("/states/lobby.lua") then
  layout[3].disabled = not app.portal.isConnected()
else
  table.remove(layout, 3)
end
if not app.exists("/lvl/8.png") then
  local item = { text = app.lang.buy, value = "buy" }
  table.insert(layout, #layout, item)
end

-- single language build
layout[4].disabled = table.count(app.text.locales) <= 1 

-- remove quit button
if app.ops.os == "Web" then
  table.remove(layout)
end

function layout.cancel()
  while app.popstate() do end
  app.pushstate("states.title")
end

function layout.choose(i)
  local q = layout[i]
  local session = game.newSession()
  if q.value == "single" then
    session.joined = 1
    app.pushstate("states.grid", "levels", session)
  elseif q.value == "coop" then
    session.joined = 2
    app.pushstate("states.grid", "levels", session)
  elseif q.value == "online" then
    app.pushstate("states.lobby", session)
  elseif q.value == "options" then
    app.pushstate("states.menu", "options")
  elseif q.value == "lang" then
    app.pushstate("states.menu", "lang")
  elseif q.value == "buy" then
    love.system.openURL(app.ops.website)
    layout.cancel()
  elseif q.value == "quit" then
    while app.popstate() do end
    love.event.quit()
  end
end

return layout