local layout = 
{
  { text = app.lang.back },
}
function layout.init(d)
  for i, a in ipairs(game.actions) do
    local k1 = app.lang[a]
    local k2 = {}
    for k, v in pairs(app.bindings[d]) do
      if v == a then
        k = game.glyphs[k] or k
        table.insert(k2, k)
      end
    end
    table.sort(k2)
    k2 = table.concat(k2, "/")
    local text = app.lang.format(app.lang.map, k1, k2 or "")
    local item = { text = text, value = a, device = d }
    table.insert(layout, 1, item)
  end
  if d ~= "Keyboard" then
    local n = 1 - (app.ops.nullzone[d] or 0.5)
    local item = { text = app.lang.sensitivity, value = n*10, device = d }
    table.insert(layout, #layout, item)
  end
end

function layout.save()
  -- save (possibly modified) bindings
  local out = 'return\n{\n'
  for k, v in pairs(app.bindings) do
    out = out..string.format("  [%q]=\n  {\n", k)
    for j, w in pairs(v) do
      if type(j) == "string" then
        j = string.format("%q", j)
      end
      out = out..string.format("    [%s]=%q,\n", j, w)
    end
    out = out.."  },\n"
  end
  out = out.."}"
  app.save(app.ops.version.."/bindings.lua", out)
end

function layout.cancel()
  layout.save()
  app.popstate()
end

function layout.choose(i, j)
  local q = layout[i]
  if i == #layout then
    layout.cancel()
  elseif j then
    q.value = j
    app.ops.nullzone[q.device] = 1 - (j/10)
    app.callstate("reset")
  else
    app.pushstate("states.capture", q.device, q.value)
  end
end

return layout