local layout =
{
  { text = app.lang.none, value = "none" },
}

local files = app.getdir("/shaders/", "frag")
for i, file in ipairs(files) do
  local n = file:match("(%a+)%.frag")
  if n ~= "mono" and n ~= "none" then
    table.insert(layout, { text = n, value = n })
  end
end

function layout.init(s)
  for i, item in ipairs(layout) do
    if item.value == app.ops.shader then
      layout.selected = i
      break
    end
  end
end

function layout.cancel()
  app.popstate()
  app.callstate("reset")
end

function layout.select(i)
  local n = layout[i].value
  app.shaders.default = app.shaders[n]
  app.ops.shader = n
end

function layout.choose(i)
  app.popstate()
end

function layout.update(dt)

end

return layout