local layout = 
{
  { text = app.lang.fullscreen, value = true },
  { text = app.lang.stretch, value = true },
  { text = app.lang.vsync, value = true },
  { text = app.lang.shaders },
  { text = app.lang.back },
}

function layout.cancel()
  app.popstate()
  app.callstate("reset")
end

function layout.init()
  layout[1].value = app.ops.fullscreen
  layout[2].value = app.ops.stretch
  layout[3].value = app.ops.vsync == 1
end

function layout.choose(i, j)
  local q = layout[i]
  if i == 1 then
    local on = not love.window.getFullscreen()
    if not love.window.setFullscreen(on) then
      return
    end
    love.mouse.setVisible(not on)
    app.ops.fullscreen = on
    local dw, dh = love.window.getDesktopDimensions(app.ops.display)
    local w, h = love.graphics.getDimensions()
    if not on and dh - h < 25 then
      love.window.maximize()
    end
    love.resize(w, h)
    q.value = on
    app.callstate("reset")
  elseif i == 2 then
    q.value = not q.value
    app.ops.stretch = q.value
    local w, h = love.graphics.getDimensions()
    love.resize(w, h)
    app.callstate("reset")
  elseif i == 3 then
    q.value = not q.value
    app.ops.shader = q.value
    app.callstate("reset")
  elseif i == 4 then
    app.pushstate("states.menu", "shaders")
  elseif i == #layout then
    layout.cancel()
  end
end

return layout