local def =
{
  music = "arcade_title",
  
  checkpoint =
  {
    {2,13},
    {92,29},
    {123,37},
    {227,52},
    {314,77},
    {402,84},
    {449,91} 
  },

  disappearing =
  {
    { {134,38},{135,38},{134,39},{135,39}, period = 6, dutycycle = 3/5, time = 4 },
    { {138,38},{139,38},{138,39},{139,39}, period = 6, dutycycle = 3/5, time = 3 },
    { {149,38},{150,38},{149,39},{150,39}, period = 6, dutycycle = 3/5, time = 1 },
    { {153,38},{154,38},{153,39},{154,39}, period = 6, dutycycle = 3/5, time = 0 },

    { {176,32},{177,32},{176,33},{177,33}, period = 6, dutycycle = 3/4, time = 6 },
    { {180,32},{181,32},{180,33},{181,33}, period = 6, dutycycle = 3/4, time = 5 },
    { {188,32},{189,32},{188,33},{189,33}, period = 6, dutycycle = 3/4, time = 3 },
    { {192,32},{193,32},{192,33},{193,33}, period = 6, dutycycle = 3/4, time = 2 },
    { {196,32},{197,32},{196,33},{197,33}, period = 6, dutycycle = 3/4, time = 1 },
    { {200,32},{201,32},{200,33},{201,33}, period = 6, dutycycle = 3/4, time = 0 },
  },
  
  bg = { 0, 0, 32 },
}

function def.update(lvl, dt)
  local pc = lvl.session.p1c
  if pc == "socket" then
    pc = lvl.session.p2c
  end
  local lang = app.lang
  if pc and pc ~= lvl.data.tc and app.bindings[pc] then
    lvl.data.tc = pc
    local bind = {}
    for k, a in pairs(app.bindings[pc]) do
      k = game.glyphs[k] or k
      if not bind[a] or lang.len(k) < lang.len(bind[a]) then
        bind[a] = k
      end
    end
    local labels =
    {
      {8.25, 12.5, 8, 2.5, text = lang.format(lang.movement, bind.left, bind.right), voice = "movement" },
      {19, 12.5, 8, 2.5, text = lang.format(lang.jumping, bind.jump), voice = "jumping" },
      {39, 19.5, 5, 2.5, text = lang.format(lang.backflip, bind.up, bind.jump), voice = "backflip" },
      {54.5, 22.5, 3.5, 3.5, text = lang.format(lang.drop, bind.down, bind.jump), voice = "drop" },
      {56, 28, 5, 2.5, text = lang.format(lang.climbing, bind.up), voice = "climbing" },
      {65, 22, 5, 2, text = lang.format(lang.rolling, bind.down, bind.right, bind.jump), voice = "rolling" },
      {78.5, 28.5, 4.5, 1.5, text = lang.format(lang.shooting, bind.shoot), voice = "shooting" },
      {92.5, 26.5, 3.5, 3.5, text = lang.enemies, voice = "enemies" },
    }
    local customized = false
    if app.bindings[pc] then
      local original = require(pc == "Keyboard" and "defs.keymap" or "defs.joymap")
      for k, v in pairs(app.bindings[pc]) do
        if original[k] ~= v then
          customized = true
          break
        end
      end
    end
    for i, v in ipairs(labels) do
      for j = 1, 4 do
        v[j] = v[j]*8
      end
      if (pc ~= "Keyboard" or customized) and i < #labels then
        v.voice = nil
      end
      lvl.newObject("label", v[1],v[2],v[3],v[4], v.text, v.voice)
    end
  end
end

return def