local T, F = true, false
local def =
{
  music = "intro_cutscene",

  checkpoint =
  {
    {2,18},
    {100,50},
    {153,57},
    {222,74},
    {264,81},
    {399,51},
  },
  
  hidden =
  {
    {92,38},
  },

  mounts =
  {
    {170,56,"s","bigegg",0,1, period = 0.3, cycle = {F,F,F,F,T,F}},
    {171,56,"s","bigegg",0,1, period = 0.3, cycle = {T,F,F,F,F,F}},
    {172,56,"s","bigegg",0,1, period = 0.3, cycle = {F,F,T,F,F,F}},
    
    {176,56,"s","bigegg",0,1, period = 0.3, cycle = {T,F,F,F}},
    {177,56,"s","bigegg",0,1, period = 0.3, cycle = {F,F,T,F}},
    {178,56,"s","bigegg",0,1, period = 0.3, cycle = {F,F,T,F}},
    
    {182,56,"s","bigegg",0,1, period = 0.3, cycle = {F,F,T,F,T,F}},
    {183,56,"s","bigegg",0,1, period = 0.3, cycle = {T,F,F,F,F,F}},
    {184,56,"s","bigegg",0,1, period = 0.3, cycle = {F,F,T,F,T,F}},
  },
  
  bg = { 64, 0, 0 },
}

local blocks =
{
  {137,56},
  {253,80},
  {292,50},
}

function def.init(lvl)
  lvl.hidden = {}
  for i, pt in ipairs(blocks) do
    lvl.hidden[i] = lvl.newObject("hidden", pt[1], pt[2])
  end
  local credit = app.lang.credit
  if app.ops.lang ~= "en" and app.lang.translator then
    credit = app.lang.format(app.lang.translation, app.lang.translator)
  end
  
  local labels =
  {
    { 283.5, 49, 9, 3, text = app.lang.victory, voice = "victory" },
    { 329.5, 47, 6, 10, text = app.lang.soundtrack },
    { 349.5, 47, 6, 10, text = app.lang.playtesting },
    { 369.5, 47, 6, 10, text = credit },
    { 389.5, 47, 6, 10, text = app.lang.thanks, voice = "thanks" },
  }
  for i, v in ipairs(labels) do
    for j = 1, 4 do
      v[j] = v[j]*8
    end
    lvl.newObject("label", v[1],v[2],v[3],v[4], v.text, v.voice)
  end
end

function def.gameover(lvl)
  local d = lvl.data
  if not d.stage and d.master and d.master.health >= 30 then
    d.over = 45
    d.coffin = true
    d.master:setState("falling", "confused")
    lvl.newObject("pallbearer", 110*8, 58*8, 1)
    lvl.newObject("pallbearer", 111*8, 58*8, 1)
    lvl.newObject("pallbearer", 112*8, 58*8, 1)
    app.playMusic("coffin_dance")
    -- coffin dance achievement
    game.progress.data["coffin"] = true
    if app.user then
      game.progress.send(app.user)
    end
  end
end

function def.update(lvl, dt)
  local d = lvl.data
  if d.over and d.over <= 45 - 5 and d.coffin then
    d.message = nil
    if d.tick%8 == 0 then
      local r = math.random(0, 255)
      local g = math.random(0, 255)
      local b = math.random(0, 255)
      lvl.view:setBackgroundRGB(r, g, b)
    end
  end
end

function def.stage(lvl, n)
  local pt = blocks[n]
  local w, h = lvl.getDimensions()
  local list = lvl.flood(pt[2]*w + pt[1] + 1)
  for _, i in ipairs(list) do
    lvl.cells[i]:toggle(false)
  end
  local sensor = lvl.hidden[n]
  sensor:toggle(false)
  lvl.destroyObject(sensor)
  lvl.data.stage = n
end

return def