local animations =
{
  chargeup = { file = "chargeup", start = 1, frames = 8, cycle = "none" },
  
  trail1 = { file = "trail", start = 1, frames = 4, cycle = "none", steps = 5 },
  trail2 = { file = "trail", start = 1, frames = 4, cycle = "none", steps = 4 },
  trail3 = { file = "trail", start = 1, frames = 4, cycle = "none", steps = 3 },

  smoke1 = { file = "smoke", start = 1, frames = 8, cycle = "none", steps = 5 },
  smoke2 = { file = "smoke", start = 1, frames = 8, cycle = "none", steps = 4 },
  smoke3 = { file = "smoke", start = 1, frames = 8, cycle = "none", steps = 3 },
  
  spark1 = { file = "spark", start = 1, frames = 4, cycle = "none", steps = 2 },
  spark2 = { file = "spark", start = 1, frames = 4, cycle = "reverse", steps = 2 },
  
  explosion = { file = "explosion", start = 1, frames = 5, cycle = "none" },
  torn = { file = "torn", start = 1, frames = 10, cycle = "none" },
}

local parent = require("obj.base")
local class = game.oo.class(parent)

class.animations = animations
class.nosleep = true

function class:init(lvl, x, y, z, name)
  parent.init(self, lvl, x, y, z)
  assert(self.animations[name], name)
  self:setAnimation(self.animations[name])
end

function class:destroy()
  parent.destroy(self)
end

function class:update(dt)
  self.elapsed = (self.elapsed or 0) + dt
  if self.elapsed >= self.animation.total then
    self.lvl.destroyObject(self)
  end
end

return class