local parent = require("obj.destructible")
local class = game.oo.class(parent)

function class:init(lvl, x, y, bits)
  parent.init(self, lvl, x, y, 2)
  local body = self.body
  self.down = body:newEdge(-4, 4, 4, 4)
  self.up = body:newEdge(-4, -4, 4, -4)
  self.left = body:newEdge(-4, -4, -4, 4)
  self.right = body:newEdge(4, -4, 4, 4)
  self.up:setFriction(0.5)
  body:setFilter(game.cat.wall, game.cat.default, 0)
  self:setGraphic("breakable")
  self.health = 3
  self.lockout = -1
  --body:setType("kinematic")
end

function class:onDie(pts)
  self:debree(16, 0, 0, 128, 128, 128)
  self.lvl.destroyCell(self)
  self:playSound("explode")
  game.screenshake(self.lvl, 0.25)
end

function class:hit(pts)
  self:damage(pts)
end

function class:shot(pts)
  self:damage(pts)
end

return class