local cat = game.cat
local animations =
{
  file = "crusher", ox = -16, oy = -18,
  standing = { start = 1, frames = 2, cycle = "loop", steps = 8 },
  strike = { start = 2, frames = 4, cycle = "none", steps = 10 },
  attack = { start = 5, frames = 1, cycle = "none" },
}

local parent = require("obj.agent")
local class = game.oo.class(parent)

class.states = require("obj.crusher-states")
class.animations = animations
class.bonus = 2000

function class:init(lvl, x, y, bits)
  parent.init(self, lvl, x, y, 5)
  --self.body:setType("kinematic")
  self.shape = self.body:newCircle(8, 0, -2.5)
  self.shape:setFilterData(cat.enemy, cat.default - cat.enemy, -2)
  self.sensor = self.body:newBox(8*16, 8*9)
  self.sensor:setFilterData(cat.enemy, cat.player + cat.wall, -2)
  self.sensor:setSensor(true)
  self:setState("spawn")
end

function class:destroy()
  self.shape = nil
  self.sensor = nil
  parent.destroy(self)
end

function class:onDamage(h)
  if h == 0 then
    self:playSound("shake")
    game.screenshake(self.lvl, 0.5)
  end
end

function class:onDie(pts)
  self:setState("dead")
end

function class:collision(other, contact)
  other:call("hit", 1)
end

function class:shot(pts)
  self:damage(pts)
end

return class