local animations =
{
  file = "debris",
  debree1 = { start = 1, frames = 8, cycle = "loop", steps = 1 },
  debree2 = { start = 1, frames = 8, cycle = "loop", steps = 2 },
  debree3 = { start = 1, frames = 8, cycle = "loop", steps = 3 },
  debree4 = { start = 1, frames = 8, cycle = "loop", steps = 4 },
  debree5 = { start = 9, frames = 8, cycle = "loop", steps = 1 },
  debree6 = { start = 9, frames = 8, cycle = "loop", steps = 2 },
  debree7 = { start = 9, frames = 8, cycle = "loop", steps = 3 },
  debree8 = { start = 9, frames = 8, cycle = "loop", steps = 4 },
  debree9 = { start = 17, frames = 8, cycle = "loop", steps = 1 },
  debree10 = { start = 17, frames = 8, cycle = "loop", steps = 2 },
  debree11 = { start = 17, frames = 8, cycle = "loop", steps = 3 },
  debree12 = { start = 17, frames = 8, cycle = "loop", steps = 4 },
  debree13 = { start = 25, frames = 8, cycle = "loop", steps = 1 },
  debree14 = { start = 25, frames = 8, cycle = "loop", steps = 2 },
  debree15 = { start = 25, frames = 8, cycle = "loop", steps = 3 },
  debree16 = { start = 25, frames = 8, cycle = "loop", steps = 4 },
}

local cat = game.cat

local parent = require("obj.fsm")
local class = game.oo.class(parent)

class.animations = animations

function class:init(lvl, x, y)
  parent.init(self, lvl, x, y, 1)
  local q = (math.random(1, 2) == 2) and -1 or 1
  self.sprite:setScale(q, 1)
  local n = math.random()*math.pi*2
  local nx, ny = math.cos(n), math.sin(n)
  --local av = math.random()*2 - 1
  local body = self.body
  body:setType("dynamic")
  body:setLinearVelocity(nx*150, ny*150)
  body:setLinearDamping(3)
  local fixture = body:newBox(2, 2)
  fixture:setFilterData(cat.debris, cat.wall, -5)
  fixture:setFriction(1)
  self.elapsed = 0
  local k = "debree"..math.random(1, 12)
  self:setAnimation(self.animations[k])
end

function class:update(dt)
--[[
  if self.makeidle then
    self.body:setAwake(false)
    local r, g, b = self.sprite:getColorRGB()
    self:setColor(r/2, g/2, b/2)
    self.makeidle = nil
  end
  ]]
  parent.update(self, dt)
  self.elapsed = self.elapsed + dt

  if self.makeidle or self.elapsed >= 5 then
    self.lvl.destroyObject(self)
  end
end

function class:collision(other, contact)
  local nx, ny = contact:getNormal()
  --if ny < 0 and other.body:getType() == "static" then
  if ny < 0 then
    self.makeidle = true
  end
end

function class:setAwake(on)
  if not on then
    self.lvl.destroyObject(self)
  end
end

return class