local parent = require("obj.trigger")
local class = game.oo.class(parent)

function class:init(lvl, x, y, z)
  parent.init(self, lvl, x, y, z)
  self.health = 1
  self.invincible = 0
  self.lockout = 0.2
end

function class:destroy()
  self.health = nil
  self.invincible = nil
  self.lockout = nil
  parent.destroy(self)
end

function class:update(dt)
  -- invincibility period
  local i = self.invincible
  if i and i > 0 or i == -1 or i == self.lockout then
    local h = self.health
    if i == self.lockout then
      self:call("onDamage", h)
    end
    if i > 0 then
      i = math.max(i - dt, 0)
    end
    if i == 0 or i == -1 or h == 0 then
      self.sprite:setShader()
      if h == 0 then
        i = -2
        self:call("onDie")
      else
        self:call("onRecover", h)
      end
    end
    self.invincible = i
  end
end

function class:damage(pts)
  local h = self.health
  if h > 0 then
    pts = pts or h
    if self.invincible == 0 or self.lockout == -1 then
      h = math.max(h - pts, 0)
      self.health = h
      self.invincible = self.lockout
      if h > 0 then
        self.sprite:setShader(app.shaders.mono)
      end
      return true
    end
  end
  return false
end

return class