local animations =
{
  file = "droplet",
  idle = { start = 8, frames = 1, cycle = "none" },
  falling = { start = 1, frames = 1, cycle = "none" },
  jumping = { start = 1, frames = 1, cycle = "none" },
  windup = { start = 1, frames = 8, cycle = "reverse", steps = 1 },
  landing = { start = 1, frames = 8, cycle = "none", steps = 1 },
  explode = { start = 9, frames = 12, cycle = "none" },
}

local cat = game.cat

local parent = require("obj.agent")
local class = game.oo.class(parent)

class.states = require("obj.droplet-states")
class.animations = animations
--class.bonus = 200

function class:init(lvl, x, y)
  local gx, gy = lvl.world:getGravity()
  local w, h = lvl.getDimensions()
  local v = 0
  for i = 1, h do
    if lvl.map[self.index + i*w] == "lava" then
      break
    end
    v = v + 1
  end
  local height = v*8
  y = y + height + 2

  parent.init(self, lvl, x, y)
  local body = self.body
  --body:setLinearDamping(3)
  body:newCircle(3)
  body:setFilter(cat.enemy, cat.player + cat.bullet, 0)
  body:setActive(false)
  self.speed = math.sqrt(2*gy*height)
  self.lockout = -1
  self:setState("spawn")
end

function class:destroy()
  self:setState()
  self.speed = nil
  self.lockout = nil
  parent.destroy(self)
end

function class:dustTrail(dt)
  --if self.elapsed%(1/60*2) - dt <= 0 then
  if self.lvl.data.tick%2 == 0 then
    local n = "trail"..math.random(1, 3)
    local anim = self:spawn("animation", 0, 0, 1, n)
    anim:setColor(128, 0, 0)
  end
end

function class:onDamage(h)
  if h == 0 then
    self:playSound("shake")  
    game.screenshake(self.lvl, 0.25)
  end
end

function class:onDie(pts)
  --self:dropBonus()
  self:setState("explode")
  self:debree(8, 0, 0, 255, 0, 0)
end

function class:collision(other, contact)
  if self.health > 0 then
    other:call("hit", 10)
    self:setState("explode")
  end
end

function class:shot(pts)
  self:damage(pts)
end

return class