local parent = require("obj.destructible")
local class = game.oo.class(parent)

function class:init(lvl, x, y, bits)
  parent.init(self, lvl, x, y, 1)
  local body = self.body
  self.down = body:newEdge(-4, 4, 4, 4)
  self.up = body:newEdge(-4, -4, 4, -4)
  self.left = body:newEdge(-4, -4, -4, 4)
  self.right = body:newEdge(4, -4, 4, 4)
  self.up:setFriction(0.5)
  body:setFilter(game.cat.wall, game.cat.default, 0)
  self:setGraphic("exploding")
  self.lockout = -1
  --body:setType("kinematic")
end

function class:wipeout()
  self.lvl.destroyCell(self)
  if self.bits > 0 then
    self:debree(6, 0, 0, 128, 128, 128)
  end
end

function class:onDie(pts)
  local lvl = self.lvl
  local list = lvl.flood(self.index)
  for i, index in ipairs(list) do
    local obj = lvl.cells[index]
    if obj then
      obj:wipeout()
    end
  end
  self:playSound("explode")
  game.screenshake(lvl, 0.25)
end

function class:shot(pts)
  self:damage(pts)
end

return class