local verts = {}
for i = 1, 32 do
  local r = i/32*math.pi*2
  local x = math.cos(r)
  local y = math.sin(r)
  table.insert(verts, { x, y })
end
local circle = love.graphics.newMesh(verts, "fan", "static")

local parent = require("obj.body")
local class = game.oo.class(parent)

function class:init(lvl, x, y, start, finish, delay)
  parent.init(self, lvl, x, y, 10)
  self.sprite:setGraphic(circle)
  --self.sprite:setShader(app.shaders.invert)
  self.body:setType("static")
  self.time = 0
  self.start = start
  self.finish = finish
  self.delay = delay
end

function class:destroy()
  self.time = nil
  self.start = nil
  self.finish = nil
  self.delay = nil
  parent.destroy(self)
end

function class:update(dt)
  self.time = self.time + dt
  local r = self.time/self.delay
  r = math.min(r, 1)
  local s = r*(self.finish - self.start) + self.start
  self.sprite:setScale(s, s)
  if r >= 1 then
    self.lvl.destroyObject(self)
  end
end

return class