local animations =
{
  file = "heart",
  blink = { start = 1, frames = 2, cycle = "loop", steps = 4 },
}

local parent = require("obj.trigger")
local class = game.oo.class(parent)

class.animations = animations

function class:init(lvl, x, y, bits)
  parent.init(self, lvl, x, y, 8)
  self:setHitbox(8/4, 8/4)
  self.body:setType("kinematic")
  self:setAnimation(self.animations["blink"])
end

function class:update(dt)
  parent.update(self, dt)
  if self:detect(game.cat.player) then
    app.say("extralife", 3)
    self:playSound("powerup")
    local s = self.lvl.session
    s.lives = s.lives + 1
    self.lvl.destroyObject(self)
  end
end

return class