local parent = require("obj.trigger")
local class = game.oo.class(parent)

class.nosleep = true

local cat = game.cat

function class:init(lvl, tx, ty)
  parent.init(self, lvl, 0, 0)

  local cache = {}
  for k, v in pairs(lvl.kinds) do
    cache[v] = true
  end
  cache["wall"] = nil
  cache["block"] = nil
  local w, h = lvl.getDimensions()
  local list = {}
  lvl.flood(ty*w + tx + 1, list, cache)
  assert(#list > 0, tx..","..ty)
  local tiles = {}
  for _, i in ipairs(list) do
    local x = i%w
    local y = (i - x)/w
    local wx, wy = x*8, y*8
    local f = self.body:newBox(4 - 1, 4 - 1, wx - 4, wy + 4)
    f:setSensor(true)
    f:setFilterData(cat.wall, cat.default, 0)
    local map = lvl.map
    local bits = 0
    if map[i + w] == "block" then
      bits = bits + 1
    end
    if map[i - w] == "block" then
      bits = bits + 2
    end
    if map[i - 1] == "block" then
      bits = bits + 4
    end
    if map[i + 1] == "block" then
      bits = bits + 8
    end
    local img = "wallc"
    --local depth = 4
    if bits == 0 then
      img = "walld"
      --depth = 9
      if map[i - w - 1] == "block" then
        bits = bits + 1
      end
      if map[i - w + 1] == "block" then
        bits = bits + 2
      end
      if map[i + w - 1] == "block" then
        bits = bits + 4
      end
      if map[i + w + 1] == "block" then
        bits = bits + 8
      end
    end
    --local obj = lvl.newObject("base", wx - 4, wy + 4, depth)
    local obj = lvl.newObject("base", wx - 4, wy + 4, 9)
    table.insert(tiles, obj)
    obj:setGraphic(img, bits + 1)
  end
  self.tiles = tiles
end

function class:destroy()
  for i, obj in ipairs(self.tiles) do
    self.lvl.destroyObject(obj)
  end
  self.tiles = nil
  parent.destroy(self)
end

function class:toggle(on)
  for i, obj in ipairs(self.tiles) do
    obj.sprite:setVisible(on)
  end
end

function class:onDetect(n)
  if not self.revealed then
    self.revealed = n > 0
    if self.revealed then
      app.playSound("discovery")
      self:toggle(false)
    end
  end
end

return class