local parent = require("obj.trigger")
local class = game.oo.class(parent)

function class:init(lvl, x, y, w, h, text, voice)
  local font = app.fonts.mini
  local fh = font:getHeight()
  local _, n = string.gsub(text, "\n", "")
  local w2 = font:getWidth(text)
  local h2 = (n + 1)*fh
  parent.init(self, lvl, x, y, 8)
  self:setHitbox(w, h)
  self.graphic = love.graphics.newText(font, "")
  self.sprite:setGraphic(self.graphic, -w2/2, -h2/2)
  self.text = text
  self.elapsed = 0
  self:setColor(255, 255, 0)
  self:loopSound("activate", 0)
  self.kind = "any"
  self.voice = voice
end

function class:destroy()
  self.sensor = nil
  self.graphic = nil
  self.text = nil
  self.elapsed = nil
  parent.destroy(self)
end

function class:setText(text)
  self.text = text
  self.elapsed = 0
end

function class:onDetect(n)
  if n > 0 then
    self.lastdetect = self.lvl.data.elapsed
    if self.voice then
      app.say(self.voice, 4)
    end
  end
end

function class:update(dt)
  parent.update(self, dt)
  local v = 0
  self.graphic:set("")
  local q = self.lastdetect
  q = q and (self.lvl.data.elapsed - q or 5)
  if (self.detected > 0) or (q and q <= 5) then
    local n = app.lang.len(self.text)
    local c = math.floor(q/1*n)
    c = math.min(c, n)
    if c < n then
      v = 1
    end
    local t = app.lang.sub(self.text, 1, c)
    self.graphic:set(t)
  end
  self:updateSound(self.loop, v)
end

return class