local states = {}

states.spawn = {}
function states.spawn:update(obj, dt)
  obj.body:setActive(true)
  obj.spawns = obj.spawns + 1
  obj:setState("idle")
end

states.idle = {}
function states.idle:update(obj, dt)
  local list = obj:getNearby(game.cat.player)
  if #list > 0 then
    obj:setState("blink")
  end
end
function states.idle:explode(obj)
  obj:setState("exploding")
end

states.blink = {}
function states.blink:enter(obj)
  obj:playSound("activate")
  obj.lifetime = 0.5
  obj.cycle = 0
end
function states.blink:exit(obj)
  obj.lifetime = nil
  obj.cycle = nil
end
function states.blink:update(obj, dt)
  obj.lifetime = obj.lifetime - dt
  if obj.lifetime <= 0 then
    obj.cycle = obj.cycle + 1
    obj.lifetime = 1/(obj.cycle*2)
    obj:playSound("activate", 1 - obj.cycle/8)
    if obj.cycle >= 8 then
      obj:setState("exploding")
    end
  end
--[[
  if obj.elapsed >= 2 then
    obj:setState("exploding")
  end
  ]]
end
function states.blink:explode(obj)
  obj:setState("exploding")
end

states.exploding = {}
function states.exploding:update(obj, dt)
  obj:explode()
  obj:setState("dead")
end

states.dead = {}
function states.dead:enter(obj)
  obj.body:setActive(false)
end
function states.dead:awake(obj)
  obj:setState("spawn")
end

return states