local animations =
{
  file = "bubbles",
  bubbles = { start = 1, frames = 8, cycle = "loop", steps = 4 },
}

local parent = require("obj.body")
local class = game.oo.class(parent)

class.animations = animations

function class:init(lvl, x, y, bits)
  parent.init(self, lvl, x, y, 7)
  self.fixture = self.body:newBox(4, 4, 0, 2)
  self.fixture:setSensor(true)
  self.fixture:setFilter(game.cat.wall, game.cat.default, 0)
  self:setGraphic("lava")
  self.elapsed = math.random()
  --if bits%4 >= 2 then
    local w, h = lvl.getDimensions()
    if lvl.isWalkable(self.index - w) then
      self:setAnimation(self.animations["bubbles"])
    end
  --end
end

function class:update(dt)
  self.elapsed = self.elapsed + dt
  local contacts = self.body:getContacts()
  for i, v in ipairs(contacts) do
    if v:isTouching() and v:isEnabled() then
      local f1, f2 = v:getFixtures()
      local other = f1:getBody()
      if other == self.body then
        other = f2:getBody()
      end
      local obj = other:getUserData()
      obj:call("hit", 100)
      if obj:getType() == "player" and math.random(2) == 1 then
        local q = table.random({ "toasty", "fishes", "chrispy" })
        app.say(q, 6)
      end
    end
  end
end

return class