local cat = game.cat
local animations =
{
  file = "pallbearer", ox = 4, oy = -8,
  shuffle = { start = 1, frames = 10, cycle = "bounce", steps = 4 },
  swing = { start = 11, frames = 5, cycle = "bounce", steps = 2 },
}

local parent = require("obj.agent")
local class = game.oo.class(parent)

class.animations = animations

function class:init(lvl, x, y, z)
  parent.init(self, lvl, x, y, z)
  self.body:setGravityScale(0)
end

function class:destroy()
  parent.destroy(self)
end

function class:update(dt)
  parent.update(self, dt)
  local e = self.lvl.data.elapsed%6/3
  local i = math.ceil(e)
  local t = { "shuffle", "swing" }
  local a = t[i]
  if a ~= self.move then
    self:setAnimation(animations[a])
    self.move = a
    local v = a == "swing" and 0 or 9
    self.body:setLinearVelocity(v, 0)
    if a == "swing" then
      game.screenshake(self.lvl, 0.5)
    end
  end
end

return class