local states = {}

states.attack = {}
function states.attack:update(obj, dt)
  local d = obj.lvl.data
  local other = d.p1 or d.p2
  if other then
    local x1, y1 = obj:getPosition()
    local x2, y2 = other:getPosition()
    local dx, dy = x2 - x1, y2 - y1
    --local d = math.sqrt(dx*dx + dy*dy)
    --if d <= obj.range then
      local t = math.atan2(dy, dx)
      local h = obj.heading
      local dist = t - h
      dist = (dist + math.pi)%(math.pi*2) - math.pi
      local step = obj.turnrate*dt
      if math.abs(dist) <= step then
        h = t
      else
        if dist < 0 then
          step = -step
        end
        h = h + step
      end
      obj.heading = h
    --end
  end
  --if d.elapsed%(1/60*5) - dt <= 0 then
  if d.tick%5 == 0 then
    local h = obj.heading
    local hx, hy = math.cos(h), math.sin(h)
    local px, py = -hx*2, -hy*2
    local n = "trail"..math.random(1, 3)
    local anim = obj:spawn("animation", px, py, 7, n)
    anim:setColor(128, 128, 128)
  end
  if obj.elapsed > 5 then
    obj:setState("dead")
  end
end

states.dead = {}
function states.dead:update(obj, dt)
  obj:playSound("shake")
  obj.lvl.destroyObject(obj)
end

return states