local cat = game.cat

local parent = require("obj.agent")
local class = game.oo.class(parent)

class.speed = 70
class.turnrate = 1/2*math.pi
class.range = 8*6

class.states = require("obj.rocket-states")

function class:init(lvl, x, y, nx, ny, mask)
  mask = mask or cat.player
  parent.init(self, lvl, x, y, 8)
  local body = self.body
  body:setGravityScale(0)
  self.shape = body:newCircle(3)
  self.shape:setFilterData(cat.enemy, cat.wall + cat.bullet + mask, -2)
  self.lockout = -1
  self.heading = math.atan2(ny, nx)
  self:setState("attack")
end

function class:destroy()
  self.shape = nil
  self.heading = nil
  parent.destroy(self)
end

function class:onDie(pts)
  --self:debree(8, 0, 0, 255, 0, 0)
  local obj = self:spawn("animation", 0, 0, 8, "torn")
  obj:setColor(255, 0, 0)
  self:setState("dead")
end

function class:update(dt)
  parent.update(self, dt)
  local h = self.heading
  local i = math.floor(h/(math.pi*2)*8 - 0.5)
  i = 9 - (i%8 + 1)
  self:setGraphic("rocket", i)
  local s = self.speed
  local hx, hy = math.cos(h), math.sin(h)
  self:setVelocity(hx*s, hy*s)
end

function class:shot(pts)
  self:damage(pts)
end

function class:hit(pts)
  self:damage(pts)
end

function class:collision(other, contact)
  --other:call("hit", 3, other, contact)
  other:call("shot", 3, other, contact)
  self:damage()
end

return class