local parent = require("obj.body")
local class = game.oo.class(parent)

function class:init(lvl, x, y, s)
  local fnt = app.fonts.intv
  local txt = love.graphics.newText(fnt, s)
  local tw = fnt:getWidth(s)
  parent.init(self, lvl, x, y, 10)
  self.body:setType("kinematic")
  self.body:setLinearVelocity(0, -10)
  self.sprite:setGraphic(txt, -tw/2, 0, 0)
  self.sprite:setPosition(x, y)
  self:setColor(255, 255, 0)
  self.time = 0
  self.score = s
  
  local d = lvl.data
  d.score = d.score + s
  -- sync progress
  local p = game.progress.data
  local n = lvl.title
  local top = math.max(p["score"..n] or 0, d.score)
  p["score"..n] = top
  if top == d.maximum then
    local q = table.random({ "maximum", "flawless", "perfect" })
    app.say(q, 8)
    p["arena"..n] = true
    if app.user then
      game.progress.send(app.user)
    end
  end
end

function class:destroy()
  local d = self.lvl.data
  local s = self.score
  if math.random(3) == 1 or d.score == s or s >= 10000 then
    local n = table.random({ "nice", "welldone", "awesome" })
    app.say(n, 3)
  end
  self.time = nil
  self.score = nil
  parent.destroy(self)
end

function class:update(dt)
  self.time = self.time + dt
  if self.time >= 1 then
    self.lvl.destroyObject(self)
  end
end

return class