local animations =
{
  file = "skullmaster",
  standing = { start = 1, frames = 2, cycle = "loop", steps = 12 },
  landing = { start = 3, frames = 1, cycle = "none" },
  hovering = { start = 6, frames = 2, cycle = "loop", steps = 12 },
  shooting = { start = 4, frames = 1, cycle = "none" },
  elbowing = { start = 14, frames = 3, cycle = "none", steps = 4 },
  spewing = { start = 8, frames = 1, cycle = "none" },
  running = { start = 9, frames = 5, cycle = "loop", steps = 2 },
  moving = { start = 6, frames = 1, cycle = "none" },
  jumping = { start = 6, frames = 1, cycle = "none" },
  falling = { start = 6, frames = 1, cycle = "none" },
  confused = { start = 17, frames = 2, cycle = "loop", steps = 12 },
  dead = { start = 3, frames = 1, cycle = "none" },
}

local parent = require("obj.agent")
local class = game.oo.class(parent)
local cat = game.cat

class.states = require("obj.skullmaster-states")
class.animations = animations
class.bonus = 10000

function class:init(lvl, x, y)
  parent.init(self, lvl, x, y)
  local body = self.body
  body:setLinearDamping(3)
  body:setMass(1000)
  self.shape = body:newBox(2, 6, 0, 2)
  self.shape:setFilterData(cat.enemy, cat.default, -2)
  self.sensor = self:spawn("trigger", 0, 2.5*8)
  self.sensor:setHitbox(11*8, 3*8)
  self:setState("spawn")
end

function class:destroy()
  self:setState()
  self.shape = nil
  self.lvl.destroyObject(self.sensor)
  self.sensor = nil
  parent.destroy(self)
end

function class:onDie(pts)
  self:setState("falling")
end

function class:collision(other, contact)
  if self.health > 0 then
    other:call("hit", 1)
  end
end

function class:shot(pts)
  self:damage(pts)
end

return class