local animations =
{
  file = "skullmasterb",
  spawn = { start = 1, frames = 2, cycle = "loop", steps = 12 },
  hovering = { start = 3, frames = 2, cycle = "loop", steps = 12 },
  hanging = { start = 5, frames = 1, cycle = "none" },
  jumping = { start = 6, frames = 1, cycle = "none" },
  falling = { start = 7, frames = 1, cycle = "none" },
  moving = { start = 13, frames = 4, cycle = "loop", steps = 2 },
  landing = { start = 8, frames = 1, cycle = "none", steps = 12 },
  standing = { start = 9, frames = 2, cycle = "loop", steps = 12 },
  attacking = { start = 11, frames = 2, cycle = "none", steps = 6 },
  dead = { start = 8, frames = 1, cycle = "none" },
}

local parent = require("obj.agent")
local class = game.oo.class(parent)
local cat = game.cat

class.states = require("obj.skullmasterb-states")
class.animations = animations
class.bonus = 10000

function class:init(lvl, x, y)
  parent.init(self, lvl, x, y, 9)
  local body = self.body
  body:setLinearDamping(2)
  body:setMass(1000)
  self.shape = body:newBox(4, 10, 0, 1)
  self.shape:setFilterData(cat.enemy, cat.default, -2)
  
  self.sensor = self:spawn("trigger", 0, 8*3)
  self.sensor:setHitbox(12*8, 5*8)
  
  self:setState("spawn")
end

function class:destroy()
  self:setState()
  self.shape = nil
  parent.destroy(self)
end

function class:onDie(pts)
  self:setState("falling")
end

function class:turn(other)
  other = other or self.sensor:detect(cat.player)
  if other then
    local x1, y1 = self:getPosition()
    local x2, y2 = other:getPosition()
    local sx = 1
    if x1 > x2 then
      sx = -1
    end
    self:setScale(sx, 1)
  end
end

function class:collision(other, contact)
  if self.health > 0 then
    other:call("hit", 1)
  end
end

function class:shot(pts)
  self:damage(pts)
end

return class