local animations =
{
  file = "skullmasterc",
  hovering = { start = 6, frames = 1, cycle = "none" },
  spinning = { start = 1, frames = 12, cycle = "loop" },
  attacking = { start = 13, frames = 3, cycle = "none", steps = 6 },
  dead = { start = 16, frames = 1, cycle = "none" },
}

local parent = require("obj.agent")
local class = game.oo.class(parent)
local cat = game.cat

class.states = require("obj.skullmasterc-states")
class.animations = animations
class.bonus = 10000

function class:init(lvl, x, y)
  y = y - 4
  parent.init(self, lvl, x, y, 9)
  local body = self.body
  body:setLinearDamping(2)
  body:setMass(1000)
  body:setGravityScale(0)
  body:setType("kinematic")
  self.shape = body:newCircle(15, 0, 0)
  self.shape:setFilterData(cat.enemy, cat.default, -2)

  self.sensor = self:spawn("trigger", 0, 8*2)
  self.sensor:setHitbox(9*8, 5*8)
  
  self:setState("spawn")
end

function class:destroy()
  self:setState()
  self.shape = nil
  parent.destroy(self)
end

function class:onDamage(h)
  if h > 1 and h%30 == 1 then
    self:spawn("explosion", 0, 0, 2, 3*8, 0.2)
    self:playSound("crush")
    game.screenshake(self.lvl, 0.25)
    local x1, y1 = self:getPosition()
    self:setPosition(x1, y1 - 8*5)
    local x2, y2 = self.sensor:getPosition()
    self.sensor:setPosition(x2, y2 - 8*5)
    self:setState("appear")
    local sx, sy = self:getScale()
    self:setScale(-sx, sy)
  end
end

function class:onDie(pts)
  self:setState("dead")
end

function class:collision(other, contact)
  if self.health > 0 then
    other:call("hit", 1)
  end
end

function class:shot(pts)
  self:damage(pts)
end

return class