local cat = game.cat
local animations =
{
  file = "spewer",
  standing = { start = 3, frames = 6, cycle = "bounce", steps = 12 },
  swingleft = { start = 1, frames = 4, cycle = "reverse", steps = 3 },
  swingright = { start = 7, frames = 4, cycle = "none", steps = 3 },
  fireleft = { start = 1, frames = 1, cycle = "none" },
  fireright = { start = 10, frames = 1, cycle = "none" },
  dead = { start = 11, frames = 1, cycle = "none" },
  spawn = { start = 11, frames = 1, cycle = "none" },
}

local parent = require("obj.agent")
local class = game.oo.class(parent)

class.states = require("obj.spewer-states")
class.animations = animations
class.bonus = 200

function class:init(lvl, x, y, bits)
  parent.init(self, lvl, x, y, 5)
  self.body:setType("kinematic")
  self.shape = self.body:newCircle(4, 0, -0.8)
  self.shape:setFilterData(cat.enemy, cat.default - cat.enemy, -2)
  self.sensor = self.body:newBox(8*16, 8*8)
  self.sensor:setFilterData(cat.enemy, cat.player, -2)
  self.sensor:setSensor(true)
  self:setState("spawn")
end

function class:destroy()
  self.shape = nil
  self.sensor = nil
  parent.destroy(self)
end

function class:onDamage(h)
  if h == 0 then
    self:playSound("shake")
    game.screenshake(self.lvl, 0.25)
  end
end

function class:onDie(pts)
  self:dropBonus()
  self:setState("dead")
  self:debree(8, 0, 0, 255, 0, 0)
end

function class:collision(other, contact)
  other:call("hit", 1)
end

function class:shot(pts)
  self:damage(pts)
end

return class