local states = {}

states.idle = {}
function states.idle:enter(obj)
  obj:reposition()
  obj:setVelocity(0, 0)
  obj:setGraphic("spike")
  obj.body:setGravityScale(0)
  obj.body:setType("kinematic")
  obj.body:setActive(true)
  obj.health = 1
end
function states.idle:update(obj, dt)
  local other = obj:detect(game.cat.player)
  if other then
    local x2, y2 = other:getPosition()
    local x1, y1 = obj:getPosition()
    local dx, dy = x2 - x1, y2 - y1
    if obj:lineOfSight(dx/8, dy/8) then
      obj:setState("falling")
    end
  end
end

states.falling = {}
function states.falling:enter(obj)
  obj:playSound("fall")  
  obj.body:setGravityScale(1)
  obj.body:setType("dynamic")
end

states.explode = {}
function states.explode:update(obj, dt)
  obj:setGraphic()
  obj.body:setActive(false)
  obj:setState("dead")
end

states.dead = {}
function states.dead:awake(obj)
  obj:setState("idle")
end

return states