local parent = require("obj.agent")
local class = game.oo.class(parent)
local cat = game.cat

class.states = require("obj.spike-states")

function class:init(lvl, x, y)
  parent.init(self, lvl, x, y, 8)
  local body = self.body
  body:setType("dynamic")
  body:setGravityScale(0)
  self.shape = body:newCircle(2.5, 0, -1)
  self.shape:setFilterData(cat.enemy, cat.wall + cat.player, -2)
  self.sensor = body:newBox(8*1.75, 8*6, 0, 8*6)
  self.sensor:setFilterData(cat.wall, cat.player, 0)
  self.sensor:setSensor(true)
  self.lockout = -1
  self:setState("idle")
end

function class:destroy()
  self.shape = nil
  self.sensor = nil
  parent.destroy(self)
end

function class:onDie()
  self:playSound("shake")  
  game.screenshake(self.lvl, 0.25)
  self:debree(6, 0, -2, 255, 255, 255)
  self:setState("explode")
end

function class:collision(other, contact)
  if self.health > 0 then
    self:damage()
    other:call("hit", 3)
  end
end

return class