local animations =
{
  file = "spikes",
  idle = { start = 1, frames = 4, cycle = "bounce" },
}

local parent = require("obj.body")
local class = game.oo.class(parent)

class.animations = animations

function class:init(lvl, x, y, bits)
  parent.init(self, lvl, x, y, 2)

  local body = self.body
  --[[
  body:newEdge(-4, 4, 4, 4)
  body:newEdge(-4, -4, -4, 4)
  body:newEdge(4, -4, 4, 4)
  self.top = body:newEdge(-4, -4, 4, -4)
  ]]
  body:newBox(3, 3)
  body:setFilter(game.cat.wall, game.cat.player, 0)
  body:setBullet(true)
  
  local a = animations["idle"]
  self.elapsed = math.random()*a.total
  self:setAnimation(a)
  local i = self.index
  local w, h = lvl.getDimensions()
  if lvl.map[i - w] ~= "wall" then
    if lvl.map[i - 1] == "wall" then
      self.sprite:setRotation(-math.pi/2)
    elseif lvl.map[i + 1] == "wall" then
      self.sprite:setRotation(math.pi/2)
    elseif lvl.map[i + w] == "wall" then
      self.sprite:setRotation(math.pi)
    end
  end
end

function class:destroy()
  --self.top = nil
  parent.destroy(self)
end

function class:update(dt)
  self.elapsed = self.elapsed + dt
  --[[
  local top = self.top
  local contacts = self.body:getContacts()
  for i, c in ipairs(contacts) do
    if c:isTouching() and c:isEnabled() then
      local f1, f2 = c:getFixtures()
      if f1 == top or f2 == top then
        local nx, ny = c:getNormal()
        local other = f1:getBody()
        if other == self.body then
          other = f2:getBody()
        end
        if ny < 0 then
          local vx, vy = other:getLinearVelocity()
          c:setEnabled(false)
          --c:setRestitution(1)
          --c:setFriction(0)
          print('oops',vy,ny)
          local obj = other:getUserData()
          obj:message("fall")
          vy = math.min(-vy, -800)
          other:setLinearVelocity(vx, vy)
          self:setAnimation(self.animations["bounce"])
          self.elapsed = 0
          self:playSound("trampoline")
          break
        end
      end
    end
  end
  ]]
end


function class:collision(other, contact)
  other:call("hit", 3)
end

return class