local states = {}

states.spawn = {}
function states.spawn:update(obj)
  obj:reposition()
  obj.sprite:setRotation(0)
  obj.body:setActive(true)
  obj:setState("move")
  obj.elapsed = 1
end

states.move = {}
function states.move:enter(obj, path)
  if path then
    obj.path = path
    obj.elapsed = obj.animations.move.total
  end
  local tx, ty = obj:getTile()
  local dx, dy = unpack(obj.path)
  local px, py = tx + dx, ty + dy
  obj.px, obj.py = px, py
  obj:turnTo(px, py)
  local w, h = obj.lvl.getDimensions()
  local t = (py - 1)*w + px
  if not obj.lvl.isWalkable(t) then
    obj:damage()  
  end
end
function states.move:update(obj, dt)
  if obj.elapsed >= obj.animations.move.total then
    local px, py = obj.px, obj.py
    obj:moveTo(px, py)
    obj:setState("move")
  end
end

states.dead = {}
function states.dead:update(obj, dt)
  obj.body:setActive(false)
  if obj.elapsed >= obj.animation.total then
    obj.lvl.destroyObject(obj)
  end
end

return states