local parent = require("states.state")
local class = parent:class()

function class:create()
  parent.create(self)
  local view = love.scene.newView()
  view:setScale(app.s, app.s)
  view:setBackgroundRGB(0, 0, 0, 255 - 16)
  self.layer = view:newLayer(0, 0)
  self.view = view
end

function class:destroy()
  self.layer:destroy()
  self.layer = nil
  self.view:destroy()
  self.view = nil
  parent.destroy(self)
end

function class:resize(w, h)
  local view = self.view
  if view then
    view:setBounds(0, 0, w, h)
    view:setScale(app.s, app.s)
  end
  self:reset()
end

function class:reset()
end

function class:draw()
  if game.lvl then
    game.draw(game.lvl)
  end
  self.view:setShader(app.shaders.default)
  self.view:draw()
end

return class