local reg = debug.getregistry()
if reg.Joystick then
  local isDown = reg.Joystick.isDown
  function reg.Joystick.isDownEx(device, b, n)
    local on = false
    if type(b) == "string" then
      local axes = device:getAxisCount()
      if b == "left" then
        on = axes >= 1 and device:getAxis(1) < -n
      elseif b == "right" then
        on = axes >= 1 and device:getAxis(1) > n
      elseif b == "up" then
        on = axes >= 2 and device:getAxis(2) < -n
      elseif b == "down" then
        on = axes >= 2 and device:getAxis(2) > n
      elseif b == "up2" then
        on = axes >= 3 and device:getAxis(3) < -n
      elseif b == "down2" then
        on = axes >= 3 and device:getAxis(3) > n
      elseif b == "left2" then
        on = axes >= 4 and device:getAxis(4) < -n
      elseif b == "right2" then
        on = axes >= 4 and device:getAxis(4) > n
      else
        local hats = device:getHatCount()
        if hats >= 1 then
          local h = device:getHat(1)
          if b == "dpup" then
            on = h == "u" or h == "lu" or h == "ru"
          elseif b == "dpdown" then
            on = h == "d" or h == "ld" or h == "rd"
          elseif b == "dpleft" then
            on = h == "l" or h == "ld" or h == "lu"
          elseif b == "dpright" then
            on = h == "r" or h == "rd" or h == "ru"
          end
        end
      end
    else
      on = isDown(device, b)
    end
    return on
  end
  
  local getAxis = reg.Joystick.getAxis
  function reg.Joystick.getAxisEx(device, a, n)
    local v = getAxis(device, a)
    local w = math.max(math.abs(v) - n, 0)
    if n < 1 and w > 0 then
      w = w/(1 - n)
      if v < 0 then
        w = -w
      end
    end
    v = w
    return v
  end
end