local oo = {}

local meta = {}
local rmeta = {}

-- Creates a new class/subclass
function oo.class(p)
  local c = setmetatable({}, { __index = p or oo })
  local mt = { __index = c }
  meta[c] = mt
  rmeta[mt] = c
  return c
end

-- Creates a new instance
function oo.instance(c)
  assert(meta[c], "undefined class")
  return setmetatable({}, meta[c])
end

-- Gets the class of an instance
function oo.getclass(i)
  local mt = getmetatable(i)
  return rmeta[mt]
end

return oo